/*
Informaatika olmpiaadi piirkondlik voor 17.01.04
Edasijudnute rhma teine lesanne (Rndkaupmees)

Autor: Mihkel Kree
Meetod: vaadatakse lbi kik vimalikud teekonnad
Testitud: gcc 3.2
*/

#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

double graaf[101][101];
int n;

double px[101];
double py[101];

// Loeb sisendandmed ning genereerib tisgraafi.
// Antud lahenduses nummerdatakse tipud 0,1,...,n-1; seda tuleb silmas
// pidada ka vljundi kirjutamisel.
void teegraaf(){
  ifstream sis("KAUP.SIS");
  sis >> n;
  for (int i=0; i<n; i++) sis >> px[i] >> py[i];

  // arvutame kaugused
  for (int i=0; i<n; i++) for (int j=0; j<n; j++){
    graaf[i][j]=sqrt((px[i]-px[j])*(px[i]-px[j])+(py[i]-py[j])*(py[i]-py[j]));
    graaf[j][i]=graaf[i][j];
  }
}

// Tagastab teekonna pikkuse.
// 'vectoris' v on iga tipp esindatud ks kord, seeprast tuleb liita
// pikkus viimasest tipust esimesse tippu.
double pikkus(vector<int> v){
  double sum=0;
  for (int i=1; i<v.size(); i++) sum+=graaf[v[i-1]][v[i]];
  sum+=graaf[v[0]][v[v.size()-1]];
  return sum;  
}

// Kirjutab vljundi, pidades meeles, et teekond algab tipust nr 0.
void prindi_vastus(vector<int> v){
  ofstream val("KAUP.VAL");
  val << pikkus(v) << endl;

  // leiame esimese tipu indeksi
  int ind=0; while (v[ind]!=0) ind++; 
  int algus=ind;

  val << "1";

  do{
    ind=(ind+1)%n;
    val << " " << v[ind]+1; // peame silmas tippude nummerdamist 0,1,..,n-1
  }while (ind!=algus);
  val << endl;
}

// Genereerime kik variandid.
void labivaatus(){
  vector<int> lahend; // seni parim teekond 
  double parimvastus=1e9;

  vector<int> perm, esialgne; // siin hoiame permutatsioone arvudest 1,2,..,n-1
  for (int i=1; i<n; i++) perm.push_back(i);
  esialgne=perm; // esialgne jarjestus
  do{
    perm.push_back(0); // lisame esimese tipu lppu
    if (parimvastus>pikkus(perm)){
      parimvastus=pikkus(perm);
      lahend=perm;
    }
    perm.pop_back(); // eemaldame tipu indeksiga 0
    // genereerime lineaarse kuluga uue jrjestuse
    next_permutation(perm.begin(), perm.end());
  }while (esialgne!=perm);

  prindi_vastus(lahend);
}

int main(){
  teegraaf();
  labivaatus();
  return 0;
}
