/*
Informaatika olmpiaadi piirkondlik voor 17.01.04
Edasijudnute rhma teine lesanne (Rndkaupmees)

Autor: Mihkel Kree
Meetod: kuni on veel aega, genereeritakse juhuslikke teekondi
Testitud: gcc 3.2
*/

#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

double graaf[101][101];
int n;

double px[101];
double py[101];

// Loeb sisendandmed ning genereerib tisgraafi.
// Antud lahenduses nummerdatakse tipud 0,1,...,n-1; seda tuleb silmas
// pidada ka vljundi kirjutamisel.
void teegraaf(){
  ifstream sis("KAUP.SIS");
  sis >> n;
  for (int i=0; i<n; i++) sis >> px[i] >> py[i];

  // arvutame kaugused
  for (int i=0; i<n; i++) for (int j=0; j<n; j++){
    graaf[i][j]=sqrt((px[i]-px[j])*(px[i]-px[j])+(py[i]-py[j])*(py[i]-py[j]));
    graaf[j][i]=graaf[i][j];
  }
}

// Tagastab teekonna pikkuse.
// 'vectoris' v on iga tipp esindatud ks kord, seeprast tuleb liita
// pikkus viimasest tipust esimesse tippu.
double pikkus(vector<int> v){
  double sum=0;
  for (int i=1; i<v.size(); i++) sum+=graaf[v[i-1]][v[i]];
  sum+=graaf[v[0]][v[v.size()-1]];
  return sum;  
}

// Kirjutab vljundi, pidades meeles, et teekond algab tipust nr 0.
void prindi_vastus(vector<int> v){
  ofstream val("KAUP.VAL");
  val << pikkus(v) << endl;

  // leiame esimese tipu indeksi
  int ind=0; while (v[ind]!=0) ind++; 
  int algus=ind;

  val << "1";

  do{
    ind=(ind+1)%n;
    val << " " << v[ind]+1; // peame silmas tippude nummerdamist 0,1,..,n-1
  }while (ind!=algus);
  val << endl;
}

// Genereerime juhuslikke permutatsioone, kuni aega on.
void naiivne_juhuslik(){
  vector<int> perm, bestperm;
  double parimvastus=1e9;

  for (int i=0; i<n; i++) perm.push_back(i);
  while (double(clock())/CLOCKS_PER_SEC<4.9){
    // ajame elemendid lineaarse kuluga juhuslikult segamini
    random_shuffle(perm.begin(), perm.end());
    if (pikkus(perm)<parimvastus){
      parimvastus=pikkus(perm);
      bestperm=perm;
    }
  }

  prindi_vastus(bestperm);
}

int main(){
  teegraaf();
  naiivne_juhuslik();
  return 0;
}
