{ 2004-01-17 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: RNDKAUPMEES                                                    }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32, TPC 6.0                                     }

{ Genereerib juhuslikke variante, kuni aega jtkub.                         }
{ Leitud lahendust pame parandada jrjestikuste linnade vahetamisega.     }
{ Kui aeg otsas, vljastab parima leitud tulemuse.                          }

uses
   dos;

const
   sisf = 'KAUP.SIS';                                    { sisendfaili nimi }
   valf = 'KAUP.VAL';                                   { vljundfaili nimi }
   maxn = 100;                                    { maksimaalne linnade arv }
   aega = 5.0 - 0.5;                 { ajalimiit, osa jtame salvestamiseks }

{ tagastab kellaaja sekundites }
function kell : real;
var h, m, s, ss : word;
begin
   gettime(h, m, s, ss);
   kell := h * 3600.0 + m * 60.0 + s + ss / 100.0;
end;

var
   n : integer;                                               { linnade arv }
   x, y : array [1..maxn] of real;                   { linnade koordinaadid }
   d : array [1..maxn, 1..maxn] of real;       { linnade vahelised kaugused }
   p : array [1..maxn] of integer;             { linnade lbimise jrjekord }
   r : real;                                            { leitud tee pikkus }
   pp : array [1..maxn] of integer;                  { seni parim jrjekord }
   rr : real;                                          { seni parima pikkus }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   i, j, k : integer;                          { abimuutujad korduste jaoks }
   tt : real;                                          { lpetamise thtaeg }
   w : boolean;                            { kas leidsime parandusvimaluse }

begin
   { mrame lpetamise thtaja }
   tt := kell + aega;            { NB! ttab valesti vahetult enne sdad }

   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, x[i], y[i]);
   close(f);

   { arvutame kikide linnade omavahelised kaugused }
   for i := 1 to n do
      for j := i + 1 to n do begin
         d[i, j] := sqrt(sqr(x[i] - x[j]) + sqr(y[i] - y[j]));
         d[j, i] := d[i, j];
      end;

   { seame otsimise algseisu }
   for i := 1 to n do
      p[i] := i;
   rr := 1e9;                { peab olema suurem kui max vimalik teepikkus }
   
   { otsime variante, kuni aega jtkub }
   while kell < tt do begin
      { uus juhuslik jrjekord }
      for i := n downto 2 do begin
         j := random(i - 1);
         k := p[i]; p[i] := p[i - j]; p[i - j] := k;
      end;
      { optimeerime jrjekorda }
      repeat
         w := false;                                  { seni parandusi pole }
         for i := 2 to n - 1 do begin
            if i = n - 1 then j := 1 else j := i + 2;
            { kas teekond (i-1)-(i+1)-i-(i+2) on lhem kui (i-1)-i-(i+1)-(i+2)? }
            if d[p[i - 1], p[i + 1]] + d[p[i], p[j]] <
                  d[p[i - 1], p[i]] + d[p[i + 1], p[j]] then begin
               k := p[i]; p[i] := p[i + 1]; p[i + 1] := k;
               w := true;                              { leidsime paranduse }
            end;
         end;
      until not w;
      { arvutame teepikkuse }
      r := 0;
      for i := 1 to n do
         r := r + d[p[i], p[i mod n + 1]];
      { kui uus parim, siis salvestame }
      if r < rr then begin
         for i := 1 to n do
            pp[i] := p[i];
         rr := r;
      end;
      { 2 vi 3 linna korral pole jrjekorral thtsust }
      { 4 linna korral saame 1. katselt parima lahenduse }
      if n < 5 then
         break;
   end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, rr);
   for i := 1 to n do
      write(f, pp[i], ' ');
   writeln(f, pp[1]);
   close(f);
end.
