{ 2004-01-17 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: RNDKAUPMEES                                                    }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32, TPC 6.0                                     }

{ Genereerib juhuslikke variante, kuni aega jtkub.                         }
{ Genereerimisel eelistab lhemaid linnu.                                   }
{ Kui aeg otsas, vljastab parima leitud tulemuse.                          }

uses
   dos;

const
   sisf = 'KAUP.SIS';                                    { sisendfaili nimi }
   valf = 'KAUP.VAL';                                   { vljundfaili nimi }
   maxn = 100;                                    { maksimaalne linnade arv }
   aega = 5.0 - 0.5;                 { ajalimiit, osa jtame salvestamiseks }

{ tagastab kellaaja sekundites }
function kell : real;
var h, m, s, ss : word;
begin
   gettime(h, m, s, ss);
   kell := h * 3600.0 + m * 60.0 + s + ss / 100.0;
end;

var
   n : integer;                                               { linnade arv }
   x, y : array [1..maxn] of real;                   { linnade koordinaadid }
   d : array [1..maxn, 1..maxn] of real;       { linnade vahelised kaugused }
   z : array [1..maxn, 1..maxn] of integer;             { kauguste indeksid }
   v : array [1..maxn] of boolean;                { kas linn on veel "vaba" }
   p : array [1..maxn] of integer;             { linnade lbimise jrjekord }
   r : real;                                            { leitud tee pikkus }
   pp : array [1..maxn] of integer;                  { seni parim jrjekord }
   rr : real;                                          { seni parima pikkus }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   i, j, k, u : integer;                       { abimuutujad korduste jaoks }
   tt : real;                                          { lpetamise thtaeg }

begin
   { mrame lpetamise thtaja }
   tt := kell + aega;            { NB! ttab valesti vahetult enne sdad }

   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, x[i], y[i]);
   close(f);

   { arvutame kikide linnade omavahelised kaugused }
   for i := 1 to n do
      for j := i + 1 to n do begin
         d[i, j] := sqrt(sqr(x[i] - x[j]) + sqr(y[i] - y[j]));
         d[j, i] := d[i, j];
      end;

   { iga linna jaoks indekseerime teised vastavalt kaugusele temast }
   for i := 1 to n do begin
      for j := 1 to n do
         z[i, j] := j;
      for j := 1 to n do
         for k := j + 1 to n do
            if d[i, z[i, j]] > d[i, z[i, k]] then begin
               u := z[i, j]; z[i, j] := z[i, k]; z[i, k] := u;
            end;
   end;
   { nd d[i, z[i, j]] <= d[i, z[i, j + 1]] iga i, j korral }

   rr := 1e9;                { peab olema suurem kui max vimalik teepikkus }

   { otsime variante, kuni aega jtkub }
   while kell < tt do begin
      { konstrueerime juhusliku "natuke ahne" jrjekorra }
      for i := 1 to n do
         v[i] := true;
      p[1] := 1; v[1] := false;
      for i := 2 to n do begin
         j := 0;
         repeat
            repeat
               j := j mod n + 1;
               k := z[p[i - 1], j];
            until v[k];
         until random(n) > ln(n);
         p[i] := k; v[k] := false;
      end;
      { arvutame teepikkuse }
      r := 0;
      for i := 1 to n do
         r := r + d[p[i], p[i mod n + 1]];
      { kui uus parim, siis salvestame }
      if r < rr then begin
         for i := 1 to n do
            pp[i] := p[i];
         rr := r;
      end;
      { 2 vi 3 linna korral pole jrjekorral thtsust }
      if n < 4 then
         break;
   end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, rr);
   for i := 1 to n do
      write(f, pp[i], ' ');
   writeln(f, pp[1]);
   close(f);
end.
