{ 2004-01-17 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: RNDKAUPMEES                                                    }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32, TPC 6.0                                     }

{ Kasutab geneetilist algoritmi.                                            }

uses
   dos;

const
   sisf = 'KAUP.SIS';                                    { sisendfaili nimi }
   valf = 'KAUP.VAL';                                   { vljundfaili nimi }
   maxlin = 100;                               { suurim lubatud linnade arv }
   maxpop = 100;                      { suurim lubatud populatsiooni suurus }
   aega = 5.0 - 0.5;                 { ajalimiit, osa jtame salvestamiseks }

{ tagastab kellaaja sekundites }
function kell : real;
var h, m, s, ss : word;
begin
   gettime(h, m, s, ss);
   kell := h * 3600.0 + m * 60.0 + s + ss / 100.0;
end;

type
   tee = record                               { see on sisuliselt geenitp }
      jrk : array [1..maxlin] of integer;      { linnade lbimise jrjekord }
      pik : real;                                              { tee pikkus }
   end;

var
   lin : integer;                                             { linnade arv }
   maa : array [1..maxlin, 1..maxlin] of real;     { vahemaad linnade vahel }
   gen : array [1..2*maxpop] of tee;                 { jooksev generatsioon }
   tt : real;                                          { lpetamise thtaeg }

{ hinnangufunktsioon - arvutab antud tee pikkuse }
procedure arvutapikkus(var t : tee);
var i : integer;
begin
   t.pik := maa[t.jrk[1], t.jrk[lin]];
   for i := 2 to lin do
      t.pik := t.pik + maa[t.jrk[i - 1], t.jrk[i]];
end;

{ genereerimisprotseduur - tekitab juhusliku tee }
procedure genereeri(var t : tee);
var i, j, x : integer;
begin
   for i := 1 to lin do
      t.jrk[i] := i;
   for i := lin downto 1 do begin
      j := 1 + random(i);
      x := t.jrk[i]; t.jrk[i] := t.jrk[j]; t.jrk[j] := x;
   end;
   arvutapikkus(t);
end;

{ ristamisprotseduur - kombineerib kahest teest he uue }
procedure kombineeri(var t1, t2, tt : tee);
var i, j, p : integer; v : array [1..maxlin] of boolean;
begin
   for i := 1 to lin do
      v[i] := true;
   i := 1 + random(lin);
   p := 1 + random(lin);
   { vtame esimesest teest p linna alates i. linnast }
   for j := 1 to p do begin
      tt.jrk[j] := t1.jrk[i];
      v[tt.jrk[j]] := false;
      i := i mod lin + 1;
   end;
   { vtame teisest teest kik lejnud jrjekorda muutmata }
   i := p;
   for j := 1 to lin do
      if v[t2.jrk[j]] then begin
         i := i + 1;
         tt.jrk[i] := t2.jrk[j];
      end;
   arvutapikkus(tt);
end;

{ muteerimisprotseduur - vahetab kaks jrjestikust linna omavahel }
procedure muteeri(var t : tee);
var i, j, x : integer;
begin
   i := 1 + random(lin);
   if i = lin then j := 1 else j := i + 1;
   x := t.jrk[i]; t.jrk[i] := t.jrk[j]; t.jrk[j] := x;
   arvutapikkus(t);
end;

{ teeb uue plvkonna - kombineerib olemasolevast pop teest pop uut }
procedure polvkond;
var i, j, k : integer;
begin
   for k := 1 to maxpop do begin
      i := maxpop - trunc(sqrt(random(sqr(maxpop))));
      j := maxpop - trunc(sqrt(random(sqr(maxpop))));
      kombineeri(gen[i], gen[j], gen[maxpop + k]);
   end;
end;

{ looduslik valik - alles jb ainult parem pool }
procedure valik;
var i, j, k : integer; t : tee;
begin
   for i := 1 to maxpop do begin
      k := i;
      for j := i + 1 to 2 * maxpop do
         if gen[k].pik > gen[j].pik then
            k := j;
      if k > i then begin
         t := gen[i]; gen[i] := gen[k]; gen[k] := t;
      end;
   end;
end;

var
   parim : tee;                                            { seni parim tee }
   i : integer;                            { abimuutuja korduste tegemiseks }

procedure sisesta;
var i, j : integer; f : text; x, y : array [1..maxlin] of real;
begin
   assign(f, sisf); reset(f);
   readln(f, lin);
   for i := 1 to lin do
      readln(f, x[i], y[i]);
   close(f);
   for i := 1 to lin do
      for j := i + 1 to lin do begin
         maa[i, j] := sqrt(sqr(x[i] - x[j]) + sqr(y[i] - y[j]));
         maa[j, i] := maa[i, j];
      end;
end;

procedure valjasta;
var i, k : integer; f : text;
begin
   k := 0;
   for i := 1 to lin do
      if parim.jrk[i] = 1 then
         k := i;
   assign(f, valf); rewrite(f);
   writeln(f, parim.pik);
   for i := 1 to lin do begin
      write(f, parim.jrk[k], ' ');
      k := k mod lin + 1;
   end;
   writeln(f, parim.jrk[k]);
   close(f);
end;

begin
   { mrame lpetamise thtaja }
   tt := kell + aega;            { NB! ttab valesti vahetult enne sdad }

   { sisestame algandmed }
   sisesta;

   { genereerime esimese plvkonna ja teeme kohe esimese valiku }
   for i := 1 to 2 * maxpop do
      genereeri(gen[i]);
   valik;
   parim := gen[1];

   { kordame kuni aega jtkub }
   while kell < tt do begin
      { genereerime uue plvkonna, teeme mutatsioonid ja valiku }
      polvkond;
      for i := 1 to round(ln(lin)) do
         muteeri(gen[1 + random(2 * maxpop)]);
      valik;
      { vrdleme senist parimat uue plvkonna parimaga }
      if parim.pik > gen[1].pik then
         parim := gen[1];
   end;

   { vljastame vastuse }
   valjasta;
end.
