/*
Informaatika olmpiaadi piirkondlik voor 17.01.04
Edasijudnute rhma teine lesanne (Rndkaupmees)

Autor: Mihkel Kree
Meetod: graafi minimaalse toesepuu phjal leitakse tippude jrjekord
Testitud: gcc 3.2
*/

#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

double graaf[101][101];
int n;

double px[101];
double py[101];

// Loeb sisendandmed ning genereerib tisgraafi.
// Antud lahenduses nummerdatakse tipud 0,1,...,n-1; seda tuleb silmas
// pidada ka vljundi kirjutamisel.
void teegraaf(){
  ifstream sis("KAUP.SIS");
  sis >> n;
  for (int i=0; i<n; i++) sis >> px[i] >> py[i];

  // arvutame kaugused
  for (int i=0; i<n; i++) for (int j=0; j<n; j++){
    graaf[i][j]=sqrt((px[i]-px[j])*(px[i]-px[j])+(py[i]-py[j])*(py[i]-py[j]));
    graaf[j][i]=graaf[i][j];
  }
}

// Tagastab teekonna pikkuse.
// 'vectoris' v on iga tipp esindatud ks kord, seeprast tuleb liita
// pikkus viimasest tipust esimesse tippu.
double pikkus(vector<int> v){
  double sum=0;
  for (int i=1; i<v.size(); i++) sum+=graaf[v[i-1]][v[i]];
  sum+=graaf[v[0]][v[v.size()-1]];
  return sum;  
}

// Kirjutab vljundi, pidades meeles, et teekond algab tipust nr 0.
void prindi_vastus(vector<int> v){
  ofstream val("KAUP.VAL");
  val << pikkus(v) << endl;

  // leiame esimese tipu indeksi
  int ind=0; while (v[ind]!=0) ind++; 
  int algus=ind;

  val << "1";

  do{
    ind=(ind+1)%n;
    val << " " << v[ind]+1; // peame silmas tippude nummerdamist 0,1,..,n-1
  }while (ind!=algus);
  val << endl;
}

vector<int> yhendus[101]; // toesepuu ise
vector<int> lahendus; // lahenduseks vajalik tippude jrjekord
bool hulgas[101]; // abimassiiv tippude eristamisks true-false meetodiga

// Lbib toesepuu (yhendus) 'preorder' jrjekorras, tulemus massiivi lahendus.
void tee_tee(int kes){
  lahendus.push_back(kes);
  hulgas[kes]=true;
  for (int i=0; i<yhendus[kes].size(); i++) if (!hulgas[yhendus[kes][i]])
    tee_tee(yhendus[kes][i]);
}

// Leiame graafile minimaalse toesepuu ning vastave tippude jrjekorra.
void mst_algoritm(){
  // algtingimus: vaid tipp 0 on toesepuus
  for (int i=0; i<n; i++) hulgas[i]=false;
  hulgas[0]=true; 

  // iga tipu jaoks vhim kaugus mingi toesepuus juba oleva tipuni
  double parimpikkus[101]; 
  int kes[101]; // missugune tosepuus juba olev tipp on lhim?

  // arvutame iga tipu kauguse tipuni 0
  for (int i=1; i<n; i++){
    parimpikkus[i]=graaf[i][0];
    kes[i]=0;
  }

  // igal sammul leiame tipu, mille yhendamine toesepuusse on kige odavam
  // uuendame ka massiivne parimpikkus ja kes
  for (int i=0; i<n-1; i++){
    double parim=1e9;
    int parimkes;
    // asmalt leime toesepuusse hendatava tipu
    for (int j=0; j<n; j++) if (!hulgas[j]) if (parimpikkus[j]<parim){
      parim=parimpikkus[j]; parimkes=j;
    }
    hulgas[parimkes]=true;

    // tiendame toesepuud
    yhendus[parimkes].push_back(kes[parimkes]);
    yhendus[kes[parimkes]].push_back(parimkes);

    // kontrollime, kas uus tipp annab paremad seosed kui senised on andnud
    for (int j=0; j<n; j++) if (!hulgas[j]) if (parimpikkus[j]>graaf[j][parimkes]){
      parimpikkus[j]=graaf[j][parimkes];
      kes[j]=parimkes;
    }
  }

  // jrgnevalt leiame tippude jrjekorra
  // proovime igat tippu panna esimeks
  double parimkogupikkus=1e9;
  vector<int> milline;
  for (int k=0; k<n; k++){
    for (int i=0; i<n; i++) hulgas[i]=false;
    tee_tee(k);
    if (pikkus(lahendus)<parimkogupikkus){
      parimkogupikkus=pikkus(lahendus);
      milline=lahendus;
    }
  }

  prindi_vastus(milline);
}

int main(){
  teegraaf();
  mst_algoritm();
  return 0;
}
