#! /usr/bin/python
# encoding: Latin-1

# 2004-01-17 programmeerimisvistluse algajate 1. lesande lahendus
# lesanne: NMEA
# Autor: Andres Soolo
# Testitud: Python 2.3.3 / Win32

# Funktsioon is_correct teeb tegeliku t ra: hindab stringina
# esitatud snumi korrektsust
def is_correct (message):
    # Alustame elementaarse vormi kontrollist:
    if len(message) < 4: # kohustuslikud "$", "*" ja kaks kontrollnumbrit
        return False
    if message[0] <> '$':
        return False
    if message[-3] <> '*':
        return False
    # Itereerime nd le snumi sisu ja genereerime ige kontrollsumma
    checksum = 0
    for ch in message[1:-3]:
        checksum = checksum ^ ord(ch)
    # Snumi lplik korrektsus sltub kontrollsumma korrektsusest
    return ('%02X' % checksum) == message[-2:]

# Avame sisendfaili ja loeme snumite arvu
infile = open('NMEA.SIS', 'r')
N = int(infile.readline())

# Avame ka vljundfaili
outfile = open('NMEA.VAL', 'w')

# Loeme kshaaval snumeid, testime neid ja vljastame otsused
for i in range(N):
    msg = infile.readline().rstrip()
    if is_correct(msg):
        outfile.write('JAH\n')
    else:
        outfile.write('EI\n')

# Lpuks sulgeme failid
infile.close()
outfile.close()
